package com.medias.annuaire;

import com.medias.ConversionException;
import com.medias.utils.Entity;
import com.medias.xml.metadata.Contact;
import org.jdom.Attribute;
import org.jdom.Element;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author combaz
 *
 * Created on 22 févr. 2005
 */
public class Personne implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static String ROLE_COORD = "coordinateur";
	public static String ROLE_TECH = "technicien";
	public static String ROLE_DEFAULT = ROLE_TECH;
	
	private String roles;
	private String nom;
	private String prenom;
	private String mail;
	private String mdp;
	private ArrayList<String> jeux;
	
	public Personne() {
		super();
		this.roles = null;
		this.nom = null;
		this.prenom = null;
		this.mail = null;
		this.mdp = null;
		this.jeux = new ArrayList<String>();
	}
	
	/**
	 * @return Returns the jeux.
	 */
	public ArrayList<String> getJeux() {
		return jeux;
	}
	/**
	 * @param jeux The jeux to set.
	 */
	public void setJeux(ArrayList<String> jeux) {
		this.jeux = jeux;
	}
	/**
	 * @return Returns the com.medias.mail.
	 */
	public String getMail() {
		return mail;
	}
	/**
	 * @param mail The com.medias.mail to set.
	 */
	public void setMail(String mail) {
		this.mail = mail;
	}
	/**
	 * @return Returns the mdp.
	 */
	public String getMdp() {
		return mdp;
	}
	/**
	 * @param mdp The mdp to set.
	 */
	public void setMdp(String mdp) {
		this.mdp = mdp;
	}
	/**
	 * @return Returns the nom.
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom The nom to set.
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return Returns the prenom.
	 */
	public String getPrenom() {
		return prenom;
	}
	/**
	 * @param prenom The prenom to set.
	 */
	public void setPrenom(String prenom) {
		this.prenom = prenom;
	}
	/**
	 * @return Returns the roles.
	 */
	public String getRoles() {
		return roles;
	}
	/**
	 * @param roles The roles to set.
	 */
	public void setRoles(String roles) {
		this.roles = roles;
	}
	/**
	 * Précise si la personne est associée ou non au jeu jeu.
	 * @param jeu 
	 * @return
	 */
	public boolean hasSet(String jeu) {
		Iterator<String> it = this.jeux.iterator();
		while(it.hasNext())
			if(((String)it.next()).equals(jeu))
				return true;
		return false;
	}
	
	public boolean removeSet(String jeu) {
		Iterator<String> it = this.jeux.iterator();
		while(it.hasNext()) {
			Object theSet = it.next();
			if(((String)theSet).equals(jeu)) {
//				System.out.println(this.com.medias.mail+" will lose the set "+jeu);
				this.jeux.remove(theSet);
				return true;
			}
		}
		return false;
	}
	
	public void fromXmlElement(Element el) throws ConversionException
    {
		Attribute r = el.getAttribute("role");
		Element n = el.getChild("nom");
		Element p = el.getChild("prenom");
		Element m = el.getChild("mail");
		Element k = el.getChild("mdp");
		List<?> j = el.getChildren("jeu");
		
		this.setRoles(r.getValue());
		this.setNom(n.getText());
		this.setPrenom(p.getText());
		this.setMail(m.getText());
		this.setMdp(k.getText());
		Iterator<?> jit = j.iterator();
		while(jit.hasNext()) {
			Element e = (Element) jit.next();
			this.jeux.add(e.getText());
		}
	}
	
	public Element toXmlElement(String title) {
		Attribute r = new Attribute("role",this.roles);
		Element n = new Element("nom");
		n.addContent(this.nom);
		Element p = new Element("prenom");
		p.addContent(this.prenom);
		Element m = new Element("mail");
		m.addContent(this.mail);
		Element k = new Element("mdp");
		k.addContent(this.mdp);
		ArrayList<Element> pl = new ArrayList<Element>();
		for(int i = 0; i<this.jeux.size(); i++) {
			Element elem = new Element("jeu");
			String jeu = (String)this.jeux.get(i);
//			System.out.println(jeu);
			elem.addContent(jeu);
			pl.add(elem);
		}
		
		Element pers = new Element(title);
		pers.setAttribute(r);
		pers.addContent(n);
		pers.addContent(p);
		pers.addContent(m);
		pers.addContent(k);
		pers.addContent(pl);
		
		return pers;
	}
	
	public void fromContact(Contact c) {
		this.setNom(c.getNom());
		this.setPrenom(c.getPrenom());
		this.setMail(c.getMail());
		this.setMdp(c.getMdp());
		this.setRoles(ROLE_DEFAULT);
	}
	
	public boolean equals(Personne p) {
		boolean result = false;
			if(/*(this.getNom().equals(p.getNom()))
					&& (this.getPrenom().equals(p.getPrenom()))
					&& */this.getMail().equals(p.getMail())
					//&& this.getMdp().equals(p.getMdp()) 
					)
				result = true;
		return result;
	}

}
