package com.medias.xml.metadata;

import com.medias.ConversionException;
import com.medias.utils.Entity;
import org.jdom.Element;

/**
 * @author combaz
 * Created on 10 févr. 2005
 * 
 * Représente un contact (une personne)
 */
public class Contact implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    private String nom;
	private String prenom;
	private String organisme;
	private String mail;
	private String mdp;
	private String role;
	private String mailOrganisme;
	private String descriptionOrganisme;
	private String adresse;
	private String urlOrganisme;
	
	public Contact() {
		super();
		this.nom = "";
		this.prenom = "";
		this.organisme = "";
		this.mail = "";
		this.mdp = "";
		this.role="default";
		this.adresse = "";
		this.descriptionOrganisme = "";
		this.mailOrganisme = "";
		this.urlOrganisme = "";
	}

	
    public String getUrlOrganisme() {
        return urlOrganisme;
    }
    public void setUrlOrganisme(String urlOrganisme) {
        this.urlOrganisme = urlOrganisme;
    }
    public String getAdresse() {
        return adresse;
    }
    public String getDescriptionOrganisme() {
        return descriptionOrganisme;
    }
    public String getMailOrganisme() {
        return mailOrganisme;
    }
    public void setAdresse(String adresse) {
        this.adresse = adresse;
    }
    public void setDescriptionOrganisme(String descriptionOrganisme) {
        this.descriptionOrganisme = descriptionOrganisme;
    }
    public void setMailOrganisme(String mailOrganisme) {
        this.mailOrganisme = mailOrganisme;
    }
	/**
	 * @return Returns the role.
	 */
	public String getRole() {
		return role;
	}
	/**
	 * @param role The role to set.
	 */
	public void setRole(String role) {
		this.role = role;
	}
	/**
	 * @return Returns the com.medias.mail.
	 */
	public String getMail() {
		return mail;
	}
	/**
	 * @param mail The com.medias.mail to set.
	 */
	public void setMail(String mail) {
		this.mail = mail;
	}
	/**
	 * @return Returns the nom.
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom The nom to set.
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return Returns the organisme.
	 */
	public String getOrganisme() {
		return organisme;
	}
	/**
	 * @param organisme The organisme to set.
	 */
	public void setOrganisme(String organisme) {
		this.organisme = organisme;
	}
	/**
	 * @return Returns the prenom.
	 */
	public String getPrenom() {
		return prenom;
	}
	/**
	 * @param prenom The prenom to set.
	 */
	public void setPrenom(String prenom) {
		this.prenom = prenom;
	}
	
	public Element toXmlElement(String title) {
		Element nom = new Element("nom");
		nom.addContent(this.nom);
		Element prenom = new Element("prenom");
		prenom.addContent(this.prenom);
		Element org = new Element("organisme");
		org.addContent(this.organisme);
		Element mail = new Element("mail");
		mail.addContent(this.mail);
		Element mdp = new Element("mdp");
		mdp.addContent(this.mdp);
		Element role = new Element("role");
		role.addContent(this.role);
		
		Element contact = new Element(title);
		contact.addContent(nom);
		contact.addContent(prenom);
		contact.addContent(org);
		contact.addContent(mail);
		contact.addContent(mdp);
		contact.addContent(role);
		
		return contact;
	}
	
	public void fromXmlElement(Element el) throws ConversionException {
		Element n = el.getChild("nom");
		Element p = el.getChild("prenom");
		Element o = el.getChild("organisme");
		Element m = el.getChild("mail");
		Element k = el.getChild("mdp");
		Element r = el.getChild("role");
		
		if((n==null)||(p==null)||(o==null)||(m==null)||(k==null)||(r==null))
			throw new ConversionException( ConversionException.ERROR_fromXml + "Contact !");
		
		else {
			this.setNom(n.getText());
			this.setPrenom(p.getText());
			this.setOrganisme(o.getText());
			this.setMail(m.getText());
			this.setMdp(k.getText());
			this.setRole(r.getText());
		}
	}
	
/*	public void reset() {
		this.nom = null;
		this.prenom = null;
		this.organisme = null;
		this.com.medias.mail = null;
	} */
	/**
	 * @return Returns the mdp.
	 */
	public String getMdp() {
		return mdp;
	}
	/**
	 * @param mdp The mdp to set.
	 */
	public void setMdp(String mdp) {
		this.mdp = mdp;
	}
	
	public boolean equals(Contact p) {
		boolean result = false;
			if(/*(this.getNom().equals(p.getNom()))
					&& (this.getPrenom().equals(p.getPrenom()))
					&& */(this.getMail().equals(p.getMail()))
					&& (this.getMdp().equals(p.getMdp())))
				result = true;
		return result;
	}
	
	public boolean isNull() {
		if((this.getMail()==null) || (this.getMail().length()==0) || (this.getMdp()==null) || (this.getMdp().length()==0))
			return true;
		else
			return false;
	}
	
	public void formToModel() {
		nom = ( nom == null ? "" : nom.trim() );
		prenom = ( prenom == null ? "" : prenom.trim() );
		organisme = ( organisme == null ? "" : organisme.trim() );
		mail = ( mail == null ? "" : mail.trim() );
		mdp = ( mdp == null ? "" : mdp.trim() );
	}
}
