package com.medias.xml.metadata;

import com.medias.ConversionException;
import com.medias.utils.Entity;
import org.jdom.Element;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author combaz
 *
 * Created on 24 févr. 2005
 */
public class Contenu implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    private ArrayList<Plateforme> plateformes;
	private ArrayList<Parametre> params;
	private ArrayList<Capteur> capteurs;
	
	
	public Contenu() {
		super();
		this.plateformes = new ArrayList<Plateforme>();
		this.params = new ArrayList<Parametre>();
		this.capteurs = new ArrayList<Capteur>();
	}
	
	public ArrayList<Capteur> getCapteurs() {
		return this.capteurs;
	}
	
	/**
	 * @param capteurs The capteurs to set.
	 */
	public void setCapteurs(ArrayList<Capteur> capteurs) {
		this.capteurs = capteurs;
	}
	
	public ArrayList<Parametre> getParams() {
		return this.params;
	}
	/**
	 * @param params The params to set.
	 */
	public void setParams(ArrayList<Parametre> params) {
		this.params = params;
	}
	
	public ArrayList<Plateforme> getPlateformes() {
		return this.plateformes;
	}

	/**
	 * @param plateformes The plateformes to set.
	 */
	public void setPlateformes(ArrayList<Plateforme> plateformes) {
		this.plateformes = plateformes;
	}
	
	public void addPlateforme() {
		Plateforme plat = new Plateforme();
		this.plateformes.add(plat);
	}
	
	public void removePlateforme(Integer idx) {
		this.plateformes.remove(idx.intValue());
	}

	public void removePlateforme(int idx) {
		this.plateformes.remove(idx);
	}

	public void addParam() {
		Parametre param = new Parametre();
		this.params.add(param);
	}
	
	public void removeParam(Integer idx) {
		this.params.remove(idx.intValue());
	}

	public void removeParam(int idx) {
		this.params.remove(idx);
	}

	public void addCapteur() {
		Capteur capt = new Capteur();
		this.capteurs.add(capt);
	}
	
	public void removeCapteur(Integer idx) {
		this.capteurs.remove(idx.intValue());
	}

	public void removeCapteur(int idx) {
		this.capteurs.remove(idx);
	}

	public Element toXmlElement(String title) {
		Element plat_elem = new Element("liste_plateformes");
		ArrayList<Element> pl = new ArrayList<Element>();
		for(int i = 0; i<this.plateformes.size(); i++) {
			Plateforme plat = (Plateforme)(this.plateformes.get(i));
			Element elem = plat.toXmlElement("plateforme");
			pl.add(elem);
		}
		plat_elem.addContent(pl);
		
		Element param_elem = new Element("liste_params");
		ArrayList<Element> pa = new ArrayList<Element>();
		for(int i = 0; i<this.params.size(); i++) {
			Parametre param = (Parametre)(this.params.get(i));
			Element elem = param.toXmlElement("param");
			pa.add(elem);
		}
		param_elem.addContent(pa);
		
		Element capt_elem = new Element("liste_capteurs");
		ArrayList<Element> ca = new ArrayList<Element>();
		for(int i = 0; i<this.capteurs.size(); i++) {
			Capteur capt = (Capteur)(this.capteurs.get(i));
			Element elem = capt.toXmlElement("capteur");
			ca.add(elem);
		}
		capt_elem.addContent(ca);
		
		Element metadata = new Element(title);
		metadata.addContent(plat_elem);
		metadata.addContent(param_elem);
		metadata.addContent(capt_elem);

		return metadata;
	}
	
	public void fromXmlElement(Element el) throws ConversionException {
		Element plat_elem = el.getChild("liste_plateformes");
		Element par_elem = el.getChild("liste_params");
		Element capt_elem = el.getChild("liste_capteurs");

		if((plat_elem==null)||(par_elem==null)||(capt_elem==null))
			throw new ConversionException(ConversionException.ERROR_fromXml + "Metadata !");
		
		else {
			List<?> pl = plat_elem.getChildren("plateforme");
			Iterator<?> plit = pl.iterator();
			while(plit.hasNext()) {
				Element elem = (Element) plit.next();
				Plateforme plat = new Plateforme();
				plat.fromXmlElement(elem);
				this.plateformes.add(plat);
			}

			List<?> pa = par_elem.getChildren("param");
			Iterator<?> pait = pa.iterator();
			while(pait.hasNext()) {
				Element elem = (Element) pait.next();
				Parametre param = new Parametre();
				param.fromXmlElement(elem);
				this.params.add(param);
			}

			List<?> ca = capt_elem.getChildren("capteur");
			Iterator<?> cait = ca.iterator();
			while(cait.hasNext()) {
				Element elem = (Element) cait.next();
				Capteur capt = new Capteur();
				capt.fromXmlElement(elem);
				this.capteurs.add(capt);
			}
		}
	}
}
