package com.medias.xml.metadata;

import com.medias.ConversionException;
import com.medias.utils.Entity;
import org.jdom.Element;

/**
 * @author combaz
 *
 * Created on 10 févr. 2005
 */
public class Description implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    private String organisme;
	private Contact pi;
	private Contact tech;
	// Uniquement pour partie dépôt de données
	private String format;
	private String repartition;
	// Ajout pour partie accès aux données
	private ExactTime dateDeb;
	private ExactTime dateFin;
	private int nbFichiers;
	private int nbMesures;
	private int jeuId;
	private double lat_min;
	private double lon_min;
	private double alt_min;
	private double lat_max;
	private double lon_max;
	private double alt_max;
	
	public Description() {
		this.organisme = null;
		this.pi = new Contact();
		this.tech = new Contact();
		this.format = null;
		this.repartition = null;
		this.dateDeb = new ExactTime();
		this.dateFin = new ExactTime();
		this.nbFichiers = 0;
		this.nbMesures = 0;
		this.lat_min = 0;
		this.lon_min = 0;
		this.alt_min = 0;
		this.lat_max = 0;
		this.lon_max = 0;
		this.alt_max = 0;
	}

	public int getNbMesures() {
		return nbMesures;
	}
	public void setNbMesures(int nbMesures) {
		this.nbMesures = nbMesures;
	}
	public int getNbFichiers() {
		return nbFichiers;
	}
	public void setNbFichiers(int nbFichiers) {
		this.nbFichiers = nbFichiers;
	}
	/**
	 * @return Returns the alt_max.
	 */
	public double getAlt_max() {
		return alt_max;
	}
	/**
	 * @param alt_max The alt_max to set.
	 */
	public void setAlt_max(double alt_max) {
		this.alt_max = alt_max;
	}
	/**
	 * @return Returns the alt_min.
	 */
	public double getAlt_min() {
		return alt_min;
	}
	/**
	 * @param alt_min The alt_min to set.
	 */
	public void setAlt_min(double alt_min) {
		this.alt_min = alt_min;
	}
	/**
	 * @return Returns the lat_max.
	 */
	public double getLat_max() {
		return lat_max;
	}
	/**
	 * @param lat_max The lat_max to set.
	 */
	public void setLat_max(double lat_max) {
		this.lat_max = lat_max;
	}
	/**
	 * @return Returns the lat_min.
	 */
	public double getLat_min() {
		return lat_min;
	}
	/**
	 * @param lat_min The lat_min to set.
	 */
	public void setLat_min(double lat_min) {
		this.lat_min = lat_min;
	}
	/**
	 * @return Returns the lon_max.
	 */
	public double getLon_max() {
		return lon_max;
	}
	/**
	 * @param lon_max The lon_max to set.
	 */
	public void setLon_max(double lon_max) {
		this.lon_max = lon_max;
	}
	/**
	 * @return Returns the lon_min.
	 */
	public double getLon_min() {
		return lon_min;
	}
	/**
	 * @param lon_min The lon_min to set.
	 */
	public void setLon_min(double lon_min) {
		this.lon_min = lon_min;
	}
	/**
	 * @return Returns the dateDeb.
	 */
	public ExactTime getDateDeb() {
		return dateDeb;
	}
	/**
	 * @param dateDeb The dateDeb to set.
	 */
	public void setDateDeb(ExactTime dateDeb) {
		this.dateDeb = dateDeb;
	}
	/**
	 * @return Returns the dateFin.
	 */
	public ExactTime getDateFin() {
		return dateFin;
	}
	/**
	 * @param dateFin The dateFin to set.
	 */
	public void setDateFin(ExactTime dateFin) {
		this.dateFin = dateFin;
	}
	/**
	 * @return Returns the format.
	 */
	public String getFormat() {
		return format;
	}
	/**
	 * @param format The format to set.
	 */
	public void setFormat(String format) {
		this.format = format;
	}
	/**
	 * @return Returns the organisme.
	 */
	public String getOrganisme() {
		return organisme;
	}
	/**
	 * @param organisme The organisme to set.
	 */
	public void setOrganisme(String organisme) {
		this.organisme = organisme;
	}
	/**
	 * @return Returns the pi.
	 */
	public Contact getPi() {
		return pi;
	}
	/**
	 * @param pi The pi to set.
	 */
	public void setPi(Contact pi) {
		this.pi = pi;
		this.pi.setRole("pi");
	}
	/**
	 * @return Returns the repartition.
	 */
	public String getRepartition() {
		return repartition;
	}
	/**
	 * @param repartition The repartition to set.
	 */
	public void setRepartition(String repartition) {
		this.repartition = repartition;
	}
	/**
	 * @return Returns the tech.
	 */
	public Contact getTech() {
		return tech;
	}
	/**
	 * @param tech The tech to set.
	 */
	public void setTech(Contact tech) {
		this.tech = tech;
		this.tech.setRole("tech");
	}
	
	public Element toXmlElement(String title) {
		Element o = new Element("organisme");
		o.addContent(this.organisme);
		Element p = this.pi.toXmlElement("pi");
		Element t = this.tech.toXmlElement("technicien");
		Element f = new Element("format");
		f.addContent(this.format);
		Element r = new Element("repartition");
		r.addContent(this.repartition);
		
		Element d = new Element(title);
		d.addContent(o);
		d.addContent(p);
		d.addContent(t);
		d.addContent(f);
		d.addContent(r);
		return d;
	}
	
	public void fromXmlElement(Element el) throws ConversionException {
		Element o = el.getChild("organisme");
		Element p = el.getChild("pi");
		Element t = el.getChild("technicien");
		Element f = el.getChild("format");
		Element r = el.getChild("repartition");
		
		if((o==null)||(p==null)||(t==null)||(f==null)||(r==null))
			throw new ConversionException(ConversionException.ERROR_fromXml + " Description !");
		
		else {
			this.setOrganisme(o.getText());
			this.pi.fromXmlElement(p);
			this.tech.fromXmlElement(t);
			this.setFormat(f.getText());
			this.setRepartition(r.getText());
		}
	}

	public int getJeuId() {
		return jeuId;
	}

	public void setJeuId(int jeuId) {
		this.jeuId = jeuId;
	}
	
}
