package com.medias.xml.metadata;

import com.medias.ConversionException;
import com.medias.utils.Entity;
import org.jdom.Element;

/**
 * @author combaz
 *
 * Created on 10 févr. 2005
 */
public class Duree implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    private int h;
	private int m;
	private double s;
	
	public Duree() {
		super();
		this.h = 0;
		this.m = 0;
		this.s = 0;
	}
	
	/**
	 * @return Returns the h.
	 */
	public int getH() {
		return h;
	}
	/**
	 * @param h The h to set.
	 */
	public void setH(int h) {
		this.h = h;
	}
	/**
	 * @return Returns the m.
	 */
	public int getM() {
		return m;
	}
	/**
	 * @param m The m to set.
	 */
	public void setM(int m) {
		this.m = m;
	}
	/**
	 * @return Returns the s.
	 */
	public double getS() {
		return s;
	}
	/**
	 * @param s The s to set.
	 */
	public void setS(double s) {
		this.s = s;
	}
	
	public Element toXmlElement(String title) {
		Element heures = new Element("nb_heures");
		heures.addContent(""+this.h);
		Element min = new Element("nb_minutes");
		min.addContent(""+this.m);
		Element sec = new Element("nb_secondes");
		sec.addContent(""+this.s);
		
		Element duree = new Element(title);
		duree.addContent(heures);
		duree.addContent(min);
		duree.addContent(sec);
		return duree;
	}
	
	public void fromXmlElement(Element el) throws ConversionException {
		Element heures = el.getChild("nb_heures");
		Element min = el.getChild("nb_minutes");
		Element sec = el.getChild("nb_secondes");
		
		if((heures==null)||(min==null)||(sec==null))
			throw new ConversionException(ConversionException.ERROR_fromXml + "Duree !");
		
		else {
			this.setH(Integer.parseInt(heures.getText()));
			this.setM(Integer.parseInt(min.getText()));
			this.setS(Double.parseDouble(sec.getText()));
		}
	}
	
/*	public void reset() {
		h = 0;
		m = 0;
		s = 0;
	} */
}
