package com.medias.xml.metadata;

import com.medias.Constantes;
import com.medias.ConversionException;
import com.medias.utils.Entity;
import org.jdom.Element;

import java.util.Comparator;

/**
 * @author combaz
 * Created on 10 févr. 2005
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Parametre implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    private String nom;
    private String nomOth;
	private String abrev;
	private String unite;
	private String uniteOth;
	// Utilisé dans la partie dépôt de données
	private String nomCapteur;
	// Utilisé dans la partie accès aux données
	private String desc;
	private String categorie;
	private String categOth;
	private String domaine;
	private String idParametre;
	
	public Parametre() {
		super();
		this.nom = "";
		this.nomOth = "";
		this.abrev = "";
		this.unite = "";
		this.uniteOth = "";
		this.categorie = "";
		this.categOth = "";
		this.domaine = "";
		this.desc = "";
		this.idParametre = null;
		this.nomCapteur = "";
	}

	
    public String getIdParametre() {
        return idParametre;
    }
    
    public void setIdParametre(String idParametre) {
        this.idParametre = idParametre;
    }
    
    public String getDesc() {
        return desc;
    }
    
    public void setDesc(String desc) {
        this.desc = desc;
    }
    
    public String getDomaine() {
        return domaine;
    }
    
    public void setDomaine(String domaine) {
        this.domaine = domaine;
    }
    
    public String getCategorie() {
        return categorie;
    }
    
    public void setCategorie(String categorie) {
        this.categorie = categorie;
    }
    
	/**
	 * @return Returns the abrev.
	 */
	public String getAbrev() {
		return abrev;
	}
	/**
	 * @param abrev The abrev to set.
	 */
	public void setAbrev(String abrev) {
		this.abrev = abrev;
	}
	/**
	 * @return Returns the nom.
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom The nom to set.
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return Returns the unite.
	 */
	public String getUnite() {
		return unite;
	}
	/**
	 * @param unite The unite to set.
	 */
	public void setUnite(String unite) {
		this.unite = unite;
	}
		
	public String getNomCapteur() {
		return nomCapteur;
	}

	public void setNomCapteur(String nomCapteur) {
		this.nomCapteur = nomCapteur;
	}

	public Element toXmlElement(String title) {
		Element n = new Element("nom");
		n.addContent(this.nom);
		Element a = new Element("abrev");
//		a.addContent(this.abrev);
		a.addContent(this.categorie);
		Element u = new Element("unite");
//		try {
//			unite = new String(unite.getBytes("ISO-8859-1"),"UTF-8");
//		} catch (UnsupportedEncodingException e) {
//			e.printStackTrace();
//		}
		u.addContent(this.unite);
		Element nomCapt = new Element("capteur");
		if (this.nomCapteur != null)
		    nomCapt.addContent(this.nomCapteur);
		else
		    nomCapt.addContent("");
		Element param = new Element(title);
		param.addContent(n);
		param.addContent(a);
		param.addContent(u);
		param.addContent(nomCapt);
		return param;
	}
	
	public void fromXmlElement(Element el) throws ConversionException
    {
		Element n = el.getChild("nom");
		Element a = el.getChild("abrev");
		Element u = el.getChild("unite");
		Element c = el.getChild("capteur");
		
		if((n==null)||(a==null)||(u==null))
			throw new ConversionException(ConversionException.ERROR_fromXml + "Parametre !");
		
		else {
//			this.setNom(n.getText());
			boolean isNomDefault = false;
			for (String nomP: Constantes.listeNomParams) {
				if (n.getText().equals(nomP)) {
					isNomDefault = true;
					break;
				}
			}
			if (isNomDefault)
				this.setNom(n.getText());
			else {
				this.setNom("-");
				this.setNomOth(n.getText());
			}
//			this.setAbrev(a.getText());
			boolean isCategDefault = false;
			for (String cat: Constantes.listeCategParams) {
				if (a.getText().equals(cat)) {
					isCategDefault = true;
					break;
				}
			}
			if (isCategDefault)
				this.setCategorie(a.getText());
			else {
				this.setCategorie("-");
				this.setCategOth(a.getText());
			}
			boolean isUnitDefault = false;
			for (String unit: Constantes.listeUnites) {
				if (u.getText().equals(unit)) {
					isUnitDefault = true;
					break;
				}
			}
			if (isUnitDefault)
				this.setUnite(u.getText());
			else {
				this.setUnite("-");
				this.setUniteOth(u.getText());
			}
			if (c==null) {
			    c = new Element("capteur");
			    c.addContent("");
			    this.setNomCapteur(c.getText());
			} else {
			    this.setNomCapteur(c.getText());
			}
		}
	}
	
	public void formToModel() {
		abrev = ( abrev == null ? "" : abrev.trim() );
//		nom = ( nom == null ? "" : nom.trim() );
		if (nom == null || nom.equals("-")) {
			if (nomOth == null) {
				nom = "";
			} else {
				nom = nomOth.trim();
			}
		} else {
			nom = nom.trim();
		}
		if (categorie == null || categorie.equals("-")) {
			if (categOth == null) {
				categorie = "";
			} else {
				categorie = categOth.trim();
			}
		} else {
			categorie = categorie.trim();
		}
//		unite = ( unite == null ? "" : unite.trim() );
		if (unite == null || unite.equals("-")) {
			if (uniteOth == null) {
				unite = "";
			} else {
				unite = uniteOth.trim();
			}
		} else {
			unite = unite.trim();
		}
	}
	
    public class ComparatorNom implements Comparator<Parametre>{
        public int compare(Parametre p1, Parametre p2){
        	return p1.getNom().compareTo(p2.getNom());
        }
    }

	public String getUniteOth() {
		return uniteOth;
	}

	public void setUniteOth(String uniteOth) {
		this.uniteOth = uniteOth;
	}


	public String getCategOth() {
		return categOth;
	}


	public void setCategOth(String categOth) {
		this.categOth = categOth;
	}


	public String getNomOth() {
		return nomOth;
	}


	public void setNomOth(String nomOth) {
		this.nomOth = nomOth;
	}
}
