package com.medias.xml.metadata;

import com.medias.Constantes;
import com.medias.ConversionException;
import com.medias.utils.Entity;
import org.apache.struts.upload.FormFile;
import org.jdom.Element;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * @author combaz
 *
 * Created on 10 févr. 2005
 */
public class Plateforme implements Entity
{
	/**
     * 
     */
    private static final long serialVersionUID = 1L;

    private FormFile newFile;
	
	private String nom;
	private String nomOth;
	private String desc;
	private ArrayList<String> liste_images;
	// Pour la partie dépôt de données
	private String lat_min;
	private String lon_min;
	private String alt_min;
	private String lat_max;
	private String lon_max;
	private String alt_max;
	// Pour la partie accès aux données
	private String typePlateforme;
	private String idPlateforme;
	
	public Plateforme() {
		super();
		this.newFile = null;
		this.nom = "";
		this.nomOth = "";
		this.desc = null;
		this.liste_images = new ArrayList<String>();
		this.lat_min = "0";
		this.lon_min = "0";
		this.alt_min = "0";
		this.lat_max = "0";
		this.lon_max = "0";
		this.alt_max = "0";
		this.typePlateforme = null;
		this.idPlateforme = null;
	}

	
    public String getIdPlateforme() {
        return idPlateforme;
    }
    
    public void setIdPlateforme(String idPlateforme) {
        this.idPlateforme = idPlateforme;
    }
    
	public String getTypePlateforme() {
		return typePlateforme;
	}
	
	public void setTypePlateforme(String typePlateforme) {
		this.typePlateforme = typePlateforme;
	}
	
	/**
	 * @return Returns the newFile.
	 */
	public FormFile getNewFile() {
		return newFile;
	}
	/**
	 * @param newFile The newFile to set.
	 */
	public void setNewFile(FormFile newFile) {
	    if (newFile == null) {
	        this.newFile = null;
	    }
	    else if (!newFile.getFileName().equals("")){
	        this.newFile = newFile;
//	        this.liste_images.add(newFile.getFileName());
		}
	}

	public String removeFile(Integer idx) {
	    String filename = liste_images.get(idx.intValue());
		this.liste_images.remove(idx.intValue());
		Iterator<String> it = liste_images.iterator();
		String img;
		while (it.hasNext()) {
		    img = (String)it.next();
		    if (img.equals("")) {
		        it.remove();
		    }
		}
		return filename;
	}
	
	/**
	 * @return Returns the nom.
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom The nom to set.
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return Returns the desc.
	 */
	public String getDesc() {
		return desc;
	}
	/**
	 * @param desc The desc to set.
	 */
	public void setDesc(String desc) {
		this.desc = desc;
	}
	/**
	 * @return Returns the images.
	 */
	public Object[] getListe_images() {
//	    if(this.liste_images.isEmpty()) {
//		    liste_images.add("");
//		}
		return this.liste_images.toArray();
	}
	
	public ArrayList<String> getListe_imagesList() {
		return this.liste_images;
	}
	/**
	 * @param images The images to set.
	 */
	public void setListe_images(String[] images) {
		this.liste_images = new ArrayList<String>();
		for(int i=0; i<images.length; i++){
		    if (!images[i].equals("")) {
		        this.liste_images.add(images[i]);
		    }
		}
	}

	/**
	 * @return Returns the alt_max.
	 */
	public String getAlt_max() {
		return alt_max;
	}
	/**
	 * @param alt_max The alt_max to set.
	 */
	public void setAlt_max(String alt_max) {
		this.alt_max = alt_max;
	}
	/**
	 * @return Returns the alt_min.
	 */
	public String getAlt_min() {
		return alt_min;
	}
	/**
	 * @param alt_min The alt_min to set.
	 */
	public void setAlt_min(String alt_min) {
		this.alt_min = alt_min;
	}
	/**
	 * @return Returns the lat_max.
	 */
	public String getLat_max() {
		return lat_max;
	}
	/**
	 * @param lat_max The lat_max to set.
	 */
	public void setLat_max(String lat_max) {
		this.lat_max = lat_max;
	}
	/**
	 * @return Returns the lat_min.
	 */
	public String getLat_min() {
		return lat_min;
	}
	/**
	 * @param lat_min The lat_min to set.
	 */
	public void setLat_min(String lat_min) {
		this.lat_min = lat_min;
	}
	/**
	 * @return Returns the lon_max.
	 */
	public String getLon_max() {
		return lon_max;
	}
	/**
	 * @param lon_max The lon_max to set.
	 */
	public void setLon_max(String lon_max) {
		this.lon_max = lon_max;
	}
	/**
	 * @return Returns the lon_min.
	 */
	public String getLon_min() {
		return lon_min;
	}
	/**
	 * @param lon_min The lon_min to set.
	 */
	public void setLon_min(String lon_min) {
		this.lon_min = lon_min;
	}
	public Element toXmlElement(String title) {
		Element n = new Element("nom");
		n.addContent(this.nom);
		Element d = new Element("desc");
		d.addContent(this.desc);
		Element im = new Element("liste_images");
		ArrayList<Element> il = new ArrayList<Element>();
		for(int i = 0; i<this.liste_images.size(); i++) {
			String img = this.liste_images.get(i);
			if (!img.equals("")) {
				Element elem = new Element("image");
				elem.addContent(img);
				il.add(elem);
			}
		}
		im.addContent(il);		
		Element lm = new Element("lat_min");
		lm.addContent(""+this.lat_min);
		Element Lm = new Element("lon_min");
		Lm.addContent(""+this.lon_min);
		Element am = new Element("alt_min");
		am.addContent(""+ this.alt_min);
		Element lM = new Element("lat_max");
		lM.addContent(""+this.lat_max);
		Element LM = new Element("lon_max");
		LM.addContent(""+this.lon_max);
		Element aM = new Element("alt_max");
		aM.addContent(""+ this.alt_max);
		
		Element plat = new Element(title);
		plat.addContent(n);
		plat.addContent(d);
		plat.addContent(im);
		plat.addContent(lm);
		plat.addContent(Lm);
		plat.addContent(am);
		plat.addContent(lM);
		plat.addContent(LM);
		plat.addContent(aM);
		return plat;
	}
	
	public void fromXmlElement(Element el) throws ConversionException {
		Element n = el.getChild("nom");
		Element d = el.getChild("desc");
		Element im = el.getChild("liste_images");
		Element lm = el.getChild("lat_min");
		Element Lm = el.getChild("lon_min");
		Element am = el.getChild("alt_min");
		Element lM = el.getChild("lat_max");
		Element LM = el.getChild("lon_max");
		Element aM = el.getChild("alt_max");
		if((lm==null)||(Lm==null)||(am==null)||(lM==null)||(LM==null)||(aM==null)) {
			Element l = el.getChild("lat");
			Element L = el.getChild("lon");
			Element a = el.getChild("alt");
			this.setNom(n.getText());
			this.setLat_min(l.getText());
			this.setLon_min(L.getText());
			this.setAlt_min(a.getText());
			this.setLat_max(l.getText());
			this.setLon_max(L.getText());
			this.setAlt_max(a.getText());
		}
		
		else {
			boolean isNomDefault = false;
			for (String nomPlat: Constantes.listePlateformes) {
				if (n.getText().equals(nomPlat)) {
					isNomDefault = true;
					break;
				}
			}
			if (isNomDefault)
				this.setNom(n.getText());
			else {
				this.setNom("-");
				this.setNomOth(n.getText());
			}
			if(d!=null)
				this.setDesc(d.getText());
			if(im!=null) {
				List<?> il = im.getChildren("image");
				if(!il.isEmpty()) {
					Iterator<?> ilit = il.iterator();
					while(ilit.hasNext()) {
						Element elem = (Element) ilit.next();
						String img = elem.getText();
						this.liste_images.add(img);
					}
				}
			}
			this.setLat_min(lm.getText());
			this.setLon_min(Lm.getText());
			this.setAlt_min(am.getText());
			this.setLat_max(lM.getText());
			this.setLon_max(LM.getText());
			this.setAlt_max(aM.getText());
		}
	}

	public void formToModel() {
		alt_max = ( alt_max == null ? "" : alt_max.trim() );
		alt_min = ( alt_min == null ? "" : alt_min.trim() );
		lat_max = ( lat_max == null ? "" : lat_max.trim() );
		lat_min = ( lat_min == null ? "" : lat_min.trim() );
		lon_max = ( lon_max == null ? "" : lon_max.trim() );
		lon_min = ( lon_min == null ? "" : lon_min.trim() );
		desc = ( desc == null ? "" : desc.trim() );
//		nom = ( (nom == null) ? "" : nom.trim() );
		if (nom == null || nom.equals("-")) {
			if (nomOth == null) {
				nom = "";
			} else {
				nom = nomOth.trim();
			}
		} else {
			nom = nom.trim();
		}
	}
	
    public class ComparatorNom implements Comparator<Plateforme>{
        public int compare(Plateforme p1, Plateforme p2){
        	return p1.getNom().compareTo(p2.getNom());
        }
    }

	public String getNomOth() {
		return nomOth;
	}


	public void setNomOth(String nomOth) {
		this.nomOth = nomOth;
	}
}
